package cz.wz.milanl.colors.organizer;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.jface.dialogs.DialogSettings;

public class CategoryItem {
	private String name;
	public List<ColorItem> colors=new LinkedList<ColorItem>();
	
	public boolean hasColor(String name)
	{
		for (int i=0;i<colors.size();i++)
		{
			if (colors.get(i).getName().equals(name))
			{
				return true;
			}
		}
		return false;
	}
	
	public CategoryItem(String name) {
		this.name = name;
	}

	public CategoryItem(DialogSettings settings) {
		load(settings);
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public void save(DialogSettings settings)
	{
		settings.put("name", getName());
		settings.put("count", colors.size());
		
		DialogSettings ds=null;
		for (int i=0;i<colors.size();i++)
		{
			ds=new DialogSettings(""+i);
			colors.get(i).save(ds);
			settings.addSection(ds);
		}
	}
	
	public void load(DialogSettings settings)
	{
		setName(settings.get("name"));
		
		colors.removeAll(null);
		
		int count=settings.getInt("count");
		
		for (int i=0;i<count;i++)
		{
			colors.add(new ColorItem((DialogSettings)settings.getSection(""+i)));
		}
	}
}
