package cz.wz.milanl.colors.organizer;

import org.eclipse.jface.dialogs.DialogSettings;
import org.eclipse.swt.graphics.RGB;

public class ColorItem {
	private String name;
	private String description;
	private RGB rgb;
	
	public ColorItem(DialogSettings settings)
	{
		load(settings);
	}
	public ColorItem(String name, String description, RGB rgb) {
		this.name = name;
		this.description = description;
		this.rgb = rgb;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public RGB getRgb() {
		return rgb;
	}

	public void setRgb(RGB rgb) {
		this.rgb = rgb;
	}

	public String getRgbString() {
		return rgb.red+","+rgb.green+","+rgb.blue;
	}

	public void setRgbString(String str) {
		String[] n=str.split(",");
		rgb=new RGB(Integer.parseInt(n[0]),Integer.parseInt(n[1]),Integer.parseInt(n[2]));
	}
	
	public void save(DialogSettings settings)
	{
		settings.put("name", getName());
		settings.put("description", getDescription());
		settings.put("rgb", getRgbString());
	}
	
	public void load(DialogSettings settings)
	{
		setName(settings.get("name"));
		setDescription(settings.get("description"));
		setRgbString(settings.get("rgb"));
	}
}
