package cz.wz.milanl.colors.organizer;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.dialogs.DialogSettings;

import cz.wz.milanl.colors.Activator;

public class Organizer {
	public List<CategoryItem> categories=new LinkedList<CategoryItem>();
	
	public boolean hasCategory(String name)
	{
		for (int i=0;i<categories.size();i++)
		{
			if (categories.get(i).getName().equals(name))
			{
				return true;
			}
		}
		return false;
	}
	
	public void save()
	{
		IPath path = Activator.getDefault().getStateLocation();
		String filename = path.append("colors.xml").toOSString();
		DialogSettings settings = new DialogSettings("colors");

		settings.put("count", categories.size());
		
		DialogSettings ds=null;
			for (int i=0;i<categories.size();i++)
			{
				ds=new DialogSettings(""+i);
				categories.get(i).save(ds);
				settings.addSection(ds);
			}
			try {
				settings.save(filename);
			} catch (IOException e) {
			}

	}
	
	public void load()
	{
		IPath path = Activator.getDefault().getStateLocation();
		String filename = path.append("colors.xml").toOSString();
		DialogSettings settings = new DialogSettings("colors");
		try {
			settings.load(filename);
			
			categories.removeAll(null);
			
			int count=settings.getInt("count");
			for (int i=0;i<count;i++)
			{
				categories.add(new CategoryItem((DialogSettings)settings.getSection(""+i)));
			}
		} catch (IOException e) {
		}
	}
}
