package cz.wz.milanl.colors.selectors;

import org.eclipse.swt.graphics.RGB;

import cz.wz.milanl.util.Numbers;

public class CMYSelector extends NumericValuesSelector {

	public CMYSelector(SelectorBar parent, String name) {
		super(parent, name, new NumericValue[] { new NumericValue("C", 0, 1000),
				new NumericValue("M", 0, 1000), new NumericValue("Y", 0, 1000), });
	}

	protected void insertValueToPrimary(RGB rgb) {
		float c=1-(float)rgb.red/255;
		float m=1-(float)rgb.green/255;
		float y=1-(float)rgb.blue/255;
		
		texts[0].setText("" + (int)(c*1000));
		texts[1].setText("" + (int)(m*1000));
		texts[2].setText("" + (int)(y*1000));
	}

	protected RGB getValue() {
		int r=(int)(((float)1-(float)Numbers.toNumber(texts[0].getText())/1000)*255);
		int g=(int)(((float)1-(float)Numbers.toNumber(texts[1].getText())/1000)*255);
		int b=(int)(((float)1-(float)Numbers.toNumber(texts[2].getText())/1000)*255);
		return new RGB(r,g,b); 
	}

	public String getCopyText(int index) {
		switch (index)
		{
			case 0: return texts[0].getText() + "," + texts[1].getText() + ","
			+ texts[2].getText();
			case 1: return texts[0].getText() + ";" + texts[1].getText() + ";"
			+ texts[2].getText();
			case 2: return texts[0].getText() + " " + texts[1].getText() + " "
			+ texts[2].getText();
			case 3: return "cmy(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 4: return "CMY(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 5: return "cmy (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 6: return "CMY (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 7: return "cmy(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 8: return "CMY(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 9: return "cmy (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 10: return "CMY (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 11: return "cmy(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 12: return "CMY(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 13: return "cmy (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 14: return "CMY (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 15: return "c:" + texts[0].getText() + ",m:" + texts[1].getText()
			+ ",y:" + texts[2].getText();
			case 16: return "C:" + texts[0].getText() + ",M:" + texts[1].getText()
			+ ",Y:" + texts[2].getText();
			case 17: return "c:" + texts[0].getText() + ";m:" + texts[1].getText()
			+ ";y:" + texts[2].getText();
			case 18: return "C:" + texts[0].getText() + ";M:" + texts[1].getText()
			+ ";Y:" + texts[2].getText();
			case 19: return "c:" + texts[0].getText() + " m:" + texts[1].getText()
			+ " y:" + texts[2].getText();
			case 20: return "C:" + texts[0].getText() + " M:" + texts[1].getText()
			+ " Y:" + texts[2].getText();
			case 21: return "cr:" + texts[0].getText() + "m:" + texts[1].getText()
			+ "y:" + texts[2].getText();
			case 22: return "C:" + texts[0].getText() + "M:" + texts[1].getText()
			+ "Y:" + texts[2].getText();
			case 23: return "c" + texts[0].getText() + ",m" + texts[1].getText()
			+ ",y" + texts[2].getText();
			case 24: return "C" + texts[0].getText() + ",M" + texts[1].getText()
			+ ",Y" + texts[2].getText();
			case 25: return "c" + texts[0].getText() + ";m" + texts[1].getText()
			+ ";y" + texts[2].getText();
			case 26: return "C" + texts[0].getText() + ";M" + texts[1].getText()
			+ ";Y" + texts[2].getText();
			case 27: return "c" + texts[0].getText() + " m" + texts[1].getText()
			+ " y" + texts[2].getText();
			case 28: return "C" + texts[0].getText() + " M" + texts[1].getText()
			+ " Y" + texts[2].getText();
			case 29: return "c" + texts[0].getText() + "m" + texts[1].getText()
			+ "y" + texts[2].getText();
			case 30: return "C" + texts[0].getText() + "M" + texts[1].getText()
			+ "Y" + texts[2].getText();
		}
		
		return null;
	}
}
