package cz.wz.milanl.colors.selectors;

import org.eclipse.swt.graphics.RGB;

import cz.wz.milanl.util.Numbers;

public class HSVSelector extends NumericValuesSelector {
	public HSVSelector(SelectorBar parent, String name) {
		super(parent, name, new NumericValue[] { new NumericValue("H", 0, 360),
				new NumericValue("S", 0, 100), new NumericValue("V", 0, 100), });
	}

	protected void insertValueToPrimary(RGB rgb) {
		texts[0].setText("" + Math.round(rgb.getHSB()[0]));
		texts[1].setText("" + Math.round(rgb.getHSB()[1] * 100));
		texts[2].setText("" + Math.round(rgb.getHSB()[2] * 100));
	}

	protected RGB getValue() {
		return new RGB((float) Numbers.toNumber(texts[0].getText()),
				(float) Numbers.toNumber(texts[1].getText()) / 100,
				(float) Numbers.toNumber(texts[2].getText()) / 100);
	}

	public String getCopyText(int index) {
		switch (index)
		{
			case 0: return texts[0].getText() + "," + texts[1].getText() + ","
			+ texts[2].getText();
			case 1: return texts[0].getText() + ";" + texts[1].getText() + ";"
			+ texts[2].getText();
			case 2: return texts[0].getText() + " " + texts[1].getText() + " "
			+ texts[2].getText();
			case 3: return "hsv(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 4: return "HSV(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 5: return "hsv (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 6: return "HSV (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 7: return "hsv(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 8: return "HSV(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 9: return "hsv (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 10: return "HSV (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 11: return "hsv(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 12: return "HSV(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 13: return "hsv (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 14: return "HSV (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 15: return "h:" + texts[0].getText() + ",s:" + texts[1].getText()
			+ ",v:" + texts[2].getText();
			case 16: return "H:" + texts[0].getText() + ",S:" + texts[1].getText()
			+ ",V:" + texts[2].getText();
			case 17: return "h:" + texts[0].getText() + ";s:" + texts[1].getText()
			+ ";v:" + texts[2].getText();
			case 18: return "H:" + texts[0].getText() + ";S:" + texts[1].getText()
			+ ";V:" + texts[2].getText();
			case 19: return "h:" + texts[0].getText() + " s:" + texts[1].getText()
			+ " v:" + texts[2].getText();
			case 20: return "H:" + texts[0].getText() + " S:" + texts[1].getText()
			+ " V:" + texts[2].getText();
			case 21: return "h:" + texts[0].getText() + "s:" + texts[1].getText()
			+ "v:" + texts[2].getText();
			case 22: return "H:" + texts[0].getText() + "S:" + texts[1].getText()
			+ "V:" + texts[2].getText();
			case 23: return "h" + texts[0].getText() + ",s" + texts[1].getText()
			+ ",v" + texts[2].getText();
			case 24: return "H" + texts[0].getText() + ",S" + texts[1].getText()
			+ ",V" + texts[2].getText();
			case 25: return "h" + texts[0].getText() + ";s" + texts[1].getText()
			+ ";v" + texts[2].getText();
			case 26: return "H" + texts[0].getText() + ";S" + texts[1].getText()
			+ ";V" + texts[2].getText();
			case 27: return "h" + texts[0].getText() + " s" + texts[1].getText()
			+ " v" + texts[2].getText();
			case 28: return "H" + texts[0].getText() + " S" + texts[1].getText()
			+ " V" + texts[2].getText();
			case 29: return "h" + texts[0].getText() + "s" + texts[1].getText()
			+ "v" + texts[2].getText();
			case 30: return "H" + texts[0].getText() + "S" + texts[1].getText()
			+ "V" + texts[2].getText();
		}

		return null;
	}
}
