package cz.wz.milanl.colors.selectors;

import org.eclipse.swt.graphics.RGB;

import cz.wz.milanl.util.Numbers;

public class HTMLCodeSelector extends OneValueSelector {
	public HTMLCodeSelector(SelectorBar parent, String name) {
		super(parent, name);
	}

	public String getCopyText(int index) {
		switch (index)
		{
			case 0: return t.getText().toLowerCase();
			case 1: return t.getText().toUpperCase();
			case 2: return (t.getText().length() > 1) ? t.getText().substring(1)
					.toLowerCase() : t.getText().toLowerCase();
			
			case 3: return (t.getText().length() > 1) ? t.getText().substring(1)
					.toUpperCase() : t.getText().toUpperCase();
		}
		return null;
	}

	protected boolean checkAllValues(boolean changeFieldColor) {
		String text = t.getText();
		if (text.length() == 7 && Numbers.isHex(text.substring(1, 7))
				&& text.charAt(0) == '#') {
			if (changeFieldColor)
				t.setBackground(defaultColor);
			return true;
		} else {
			if (changeFieldColor)
				t.setBackground(errorColor);
			return false;
		}
	}

	protected RGB getValue() {
		String text = t.getText();
		return new RGB(Numbers.fromHex(text.substring(1, 3)), Numbers
				.fromHex(text.substring(3, 5)), Numbers.fromHex(text.substring(
				5, 7)));
	}

	protected void insertTextToPrimary(String text) {
		t.setText("#" + new String(Numbers.getFirstHexNumbers(text, 6, 'x')));
	}

	protected void insertValueToPrimary(RGB rgb) {
		t.setText("#" + Numbers.toHex(rgb.red) + Numbers.toHex(rgb.green)
				+ Numbers.toHex(rgb.blue));
	}

	protected void refreshPrimaryIndicatorFields() {

	}

	protected void refreshSecondaryIndicatorFields() {

	}
}
