package cz.wz.milanl.colors.selectors;

import java.io.IOException;
import java.io.InputStream;

import cz.wz.milanl.util.LinesExtractor;
import cz.wz.milanl.util.Numbers;

public class HTMLNameSelector extends ListSelector {

	public HTMLNameSelector(SelectorBar parent, String name) {
		super(parent, name);
	}

	protected ColorListItem[] getColorListItems() {
		ColorListItem[] colorItems = null;
		InputStream is = getClass().getResourceAsStream("/res/names.txt");
		try {
			byte[] bytes = new byte[is.available()];
			is.read(bytes);
			String[] list = LinesExtractor.textToLines(new String(bytes));
			colorItems = new ColorListItem[list.length];
			for (int i = 0; i < colorItems.length; i++) {
				colorItems[i] = new ColorListItem();
				int dPos = list[i].indexOf('#');
				colorItems[i].name = list[i].substring(0, dPos);
				colorItems[i].r = Numbers.fromHex(list[i].substring(dPos + 1,
						dPos + 3));
				colorItems[i].g = Numbers.fromHex(list[i].substring(dPos + 3,
						dPos + 5));
				colorItems[i].b = Numbers.fromHex(list[i].substring(dPos + 5,
						dPos + 7));
			}
		} catch (IOException e) {
		}

		return colorItems;
	}
}
