package cz.wz.milanl.colors.selectors;

import org.eclipse.swt.graphics.RGB;

import cz.wz.milanl.util.Numbers;

public class PercentSelector extends NumericValuesSelector {
	public PercentSelector(SelectorBar parent, String name) {
		super(parent, name, new NumericValue[] {
				new NumericValue("%R", 0, 100), new NumericValue("%G", 0, 100),
				new NumericValue("%B", 0, 100), });
	}

	protected void insertValueToPrimary(RGB rgb) {
		texts[0].setText("" + rgb.red * 100 / 255);
		texts[1].setText("" + rgb.green * 100 / 255);
		texts[2].setText("" + rgb.blue * 100 / 255);
	}

	protected RGB getValue() {
		return new RGB(Numbers.toNumber(texts[0].getText()) * 255 / 100,
				Numbers.toNumber(texts[1].getText()) * 255 / 100, Numbers
						.toNumber(texts[2].getText()) * 255 / 100);
	}

	public String getCopyText(int index) {
		switch (index)
		{
			case 0: return texts[0].getText() + "%," + texts[1].getText() + "%,"
			+ texts[2].getText() + "%";
			case 1: return texts[0].getText() + "%;" + texts[1].getText() + "%;"
			+ texts[2].getText() + "%";
			case 2: return texts[0].getText() + "% " + texts[1].getText() + "% "
			+ texts[2].getText() + "%";
			case 3: return "rgb(" + texts[0].getText() + "%," + texts[1].getText()
			+ "%," + texts[2].getText() + "%)";
			case 4: return "RGB(" + texts[0].getText() + "%," + texts[1].getText()
			+ "%," + texts[2].getText() + "%)";
			case 5: return "rgb (" + texts[0].getText() + "%," + texts[1].getText()
			+ "%," + texts[2].getText() + "%)";
			case 6: return "RGB (" + texts[0].getText() + "%," + texts[1].getText()
			+ "%," + texts[2].getText() + "%)";
			case 7: return "rgb(" + texts[0].getText() + "%;" + texts[1].getText()
			+ "%;" + texts[2].getText() + "%)";
			case 8: return "RGB(" + texts[0].getText() + "%;" + texts[1].getText()
			+ "%;" + texts[2].getText() + "%)";
			case 9: return "rgb (" + texts[0].getText() + "%;" + texts[1].getText()
			+ "%;" + texts[2].getText() + "%)";
			case 10: return "RGB (" + texts[0].getText() + "%;" + texts[1].getText()
			+ "%;" + texts[2].getText() + "%)";
			case 11: return "rgb(" + texts[0].getText() + "% " + texts[1].getText()
			+ "% " + texts[2].getText() + "%)";
			case 12: return "RGB(" + texts[0].getText() + "% " + texts[1].getText()
			+ "% " + texts[2].getText() + "%)";
			case 13: return "rgb (" + texts[0].getText() + "% " + texts[1].getText()
			+ "% " + texts[2].getText() + "%)";
			case 14: return "RGB (" + texts[0].getText() + "% " + texts[1].getText()
			+ "% " + texts[2].getText() + "%)";
			case 15: return "r:" + texts[0].getText() + "%,g:" + texts[1].getText()
			+ "%,b:" + texts[2].getText() + "%";
			case 16: return "R:" + texts[0].getText() + "%,G:" + texts[1].getText()
			+ "%,B:" + texts[2].getText() + "%";
			case 17: return "r:" + texts[0].getText() + "%;g:" + texts[1].getText()
			+ "%;b:" + texts[2].getText() + "%";
			case 18: return "R:" + texts[0].getText() + "%;G:" + texts[1].getText()
			+ "%;B:" + texts[2].getText() + "%";
			case 19: return "r:" + texts[0].getText() + "% g:" + texts[1].getText()
			+ "% b:" + texts[2].getText() + "%";
			case 20: return "R:" + texts[0].getText() + "% G:" + texts[1].getText()
			+ "% B:" + texts[2].getText() + "%";
			case 21: return "r:" + texts[0].getText() + "%g:" + texts[1].getText()
			+ "%b:" + texts[2].getText() + "%";
			case 22: return "R:" + texts[0].getText() + "%G:" + texts[1].getText()
			+ "%B:" + texts[2].getText() + "%";
			case 23: return "r" + texts[0].getText() + "%,g" + texts[1].getText()
			+ "%,b" + texts[2].getText() + "%";
			case 24: return "R" + texts[0].getText() + "%,G" + texts[1].getText()
			+ "%,B" + texts[2].getText() + "%";
			case 25: return "r" + texts[0].getText() + "%;g" + texts[1].getText()
			+ "%;b" + texts[2].getText() + "%";
			case 26: return "R" + texts[0].getText() + "%;G" + texts[1].getText()
			+ "%;B" + texts[2].getText() + "%";
			case 27: return "r" + texts[0].getText() + "% g" + texts[1].getText()
			+ "% b" + texts[2].getText() + "%";
			case 28: return "R" + texts[0].getText() + "% G" + texts[1].getText()
			+ "% B" + texts[2].getText() + "%";
			case 29: return "r" + texts[0].getText() + "%g" + texts[1].getText()
			+ "%b" + texts[2].getText() + "%";
			case 30: return "R" + texts[0].getText() + "%G" + texts[1].getText()
			+ "%B" + texts[2].getText() + "%";
			case 31: return texts[0].getText() + "," + texts[1].getText() + ","
			+ texts[2].getText();
			case 32: return texts[0].getText() + ";" + texts[1].getText() + ";"
			+ texts[2].getText();
			case 33: return texts[0].getText() + " " + texts[1].getText() + " "
			+ texts[2].getText();
			case 34: return "rgb(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 35: return "RGB(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 36: return "rgb (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 37: return "RGB (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 38: return "rgb(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 39: return "RGB(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 40: return "rgb (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 41: return "RGB (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 42: return "rgb(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 43: return "RGB(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 44: return "rgb (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 45: return "RGB (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 46: return "r:" + texts[0].getText() + ",g:" + texts[1].getText()
			+ ",b:" + texts[2].getText();
			case 47: return "R:" + texts[0].getText() + ",G:" + texts[1].getText()
			+ ",B:" + texts[2].getText();
			case 48: return "r:" + texts[0].getText() + ";g:" + texts[1].getText()
			+ ";b:" + texts[2].getText();
			case 49: return "R:" + texts[0].getText() + ";G:" + texts[1].getText()
			+ ";B:" + texts[2].getText();
			case 50: return "r:" + texts[0].getText() + " g:" + texts[1].getText()
			+ " b:" + texts[2].getText();
			case 51: return "R:" + texts[0].getText() + " G:" + texts[1].getText()
			+ " B:" + texts[2].getText();
			case 52: return "r:" + texts[0].getText() + "g:" + texts[1].getText()
			+ "b:" + texts[2].getText();
			case 53: return "R:" + texts[0].getText() + "G:" + texts[1].getText()
			+ "B:" + texts[2].getText();
			case 54: return "r" + texts[0].getText() + ",g" + texts[1].getText()
			+ ",b" + texts[2].getText();
			case 55: return "R" + texts[0].getText() + ",G" + texts[1].getText()
			+ ",B" + texts[2].getText();
			case 56: return "r" + texts[0].getText() + ";g" + texts[1].getText()
			+ ";b" + texts[2].getText();
			case 57: return "R" + texts[0].getText() + ";G" + texts[1].getText()
			+ ";B" + texts[2].getText();
			case 58: return "r" + texts[0].getText() + " g" + texts[1].getText()
			+ " b" + texts[2].getText();
			case 59: return "R" + texts[0].getText() + " G" + texts[1].getText()
			+ " B" + texts[2].getText();
			case 60: return "r" + texts[0].getText() + "g" + texts[1].getText()
			+ "b" + texts[2].getText();
			case 61: return "R" + texts[0].getText() + "G" + texts[1].getText()
			+ "B" + texts[2].getText();
		}
		return null;
	}
}
