package cz.wz.milanl.colors.selectors;

import org.eclipse.swt.graphics.RGB;

import cz.wz.milanl.util.Numbers;

public class RGBSelector extends NumericValuesSelector {

	public RGBSelector(SelectorBar parent, String name) {
		super(parent, name, new NumericValue[] { new NumericValue("R", 0, 255),
				new NumericValue("G", 0, 255), new NumericValue("B", 0, 255), });
	}

	protected void insertValueToPrimary(RGB rgb) {
		texts[0].setText("" + rgb.red);
		texts[1].setText("" + rgb.green);
		texts[2].setText("" + rgb.blue);
	}

	protected RGB getValue() {
		return new RGB(Numbers.toNumber(texts[0].getText()), Numbers
				.toNumber(texts[1].getText()), Numbers.toNumber(texts[2]
				.getText()));
	}

	public String getCopyText(int index) {
		switch (index)
		{
			case 0: return texts[0].getText() + "," + texts[1].getText() + ","
			+ texts[2].getText();
			case 1: return texts[0].getText() + ";" + texts[1].getText() + ";"
			+ texts[2].getText();
			case 2: return texts[0].getText() + " " + texts[1].getText() + " "
			+ texts[2].getText();
			case 3: return "rgb(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 4: return "RGB(" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 5: return "rgb (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 6: return "RGB (" + texts[0].getText() + "," + texts[1].getText()
			+ "," + texts[2].getText() + ")";
			case 7: return "rgb(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 8: return "RGB(" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 9: return "rgb (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 10: return "RGB (" + texts[0].getText() + ";" + texts[1].getText()
			+ ";" + texts[2].getText() + ")";
			case 11: return "rgb(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 12: return "RGB(" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 13: return "rgb (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 14: return "RGB (" + texts[0].getText() + " " + texts[1].getText()
			+ " " + texts[2].getText() + ")";
			case 15: return "r:" + texts[0].getText() + ",g:" + texts[1].getText()
			+ ",b:" + texts[2].getText();
			case 16: return "R:" + texts[0].getText() + ",G:" + texts[1].getText()
			+ ",B:" + texts[2].getText();
			case 17: return "r:" + texts[0].getText() + ";g:" + texts[1].getText()
			+ ";b:" + texts[2].getText();
			case 18: return "R:" + texts[0].getText() + ";G:" + texts[1].getText()
			+ ";B:" + texts[2].getText();
			case 19: return "r:" + texts[0].getText() + " g:" + texts[1].getText()
			+ " b:" + texts[2].getText();
			case 20: return "R:" + texts[0].getText() + " G:" + texts[1].getText()
			+ " B:" + texts[2].getText();
			case 21: return "r:" + texts[0].getText() + "g:" + texts[1].getText()
			+ "b:" + texts[2].getText();
			case 22: return "R:" + texts[0].getText() + "G:" + texts[1].getText()
			+ "B:" + texts[2].getText();
			case 23: return "r" + texts[0].getText() + ",g" + texts[1].getText()
			+ ",b" + texts[2].getText();
			case 24: return "R" + texts[0].getText() + ",G" + texts[1].getText()
			+ ",B" + texts[2].getText();
			case 25: return "r" + texts[0].getText() + ";g" + texts[1].getText()
			+ ";b" + texts[2].getText();
			case 26: return "R" + texts[0].getText() + ";G" + texts[1].getText()
			+ ";B" + texts[2].getText();
			case 27: return "r" + texts[0].getText() + " g" + texts[1].getText()
			+ " b" + texts[2].getText();
			case 28: return "R" + texts[0].getText() + " G" + texts[1].getText()
			+ " B" + texts[2].getText();
			case 29: return "r" + texts[0].getText() + "g" + texts[1].getText()
			+ "b" + texts[2].getText();
			case 30: return "R" + texts[0].getText() + "G" + texts[1].getText()
			+ "B" + texts[2].getText();
		}
		
		return null;
	}
}
