package cz.wz.milanl.colors.selectors;

import java.util.LinkedList;

import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;

import cz.wz.milanl.colors.views.ColorView;
import cz.wz.milanl.colors.views.Colors;

public class SelectorBar extends Composite {
	public Colors colors;
	public ColorView colorView;
	
	LinkedList<ColorSelector> selectors=new LinkedList<ColorSelector>();

	public SelectorBar(Composite parent, Colors colors, ColorView colorView) {
		super(parent, 0);
		this.colors = colors;
		this.colorView = colorView;
		setLayout(new FormLayout());
	}

	public void refreshPositions() {
		int top = 0;
		for (int i = 0; i < selectors.size(); i++) {
			FormData data = new FormData();
			data.top = new FormAttachment(0, top);

			top += selectors.get(i).getHeight();

			data.bottom = new FormAttachment(0, top);
			data.left = new FormAttachment(0);
			data.right = new FormAttachment(100);
			selectors.get(i).setLayoutData(data);
		}
		layout(false);
	}

	public void addColorSelector(int index,ColorSelector colorSelector) {
		selectors.add(index, colorSelector);
	}

	public void removeColorSelector(Class<? extends ColorSelector> cl, boolean dispose)
	{
		for (int i=0;i<selectors.size();i++)
		{
			if (selectors.get(i).getClass()==cl)
			{
				if (dispose) selectors.get(i).dispose();
				selectors.remove(i);
				return;
			}
		}
	}
	
	public ColorSelector getColorSelector(Class<? extends ColorSelector> cl)
	{
		for (int i=0;i<selectors.size();i++)
		{
			if (selectors.get(i).getClass()==cl)
			{
				return selectors.get(i);
			}
		}
		return null;
	}
	
	public void refreshAllSelectors(ColorSelector ignore) {
		for (int i = 0; i < selectors.size(); i++) {
			if (ignore != selectors.get(i)) {
				((ColorSelector) selectors.get(i)).colorIn();
				((ColorSelector) selectors.get(i)).restoreFieldColors();
			}
		}
	}

	public void refreshAllSelectors() {
		refreshAllSelectors(null);
	}

	public void disableAutoClipboardActions() {
		for (int i = 0; i < selectors.size(); i++) {
			selectors.get(i).setAutoCopyToClipboard(false);
			selectors.get(i).setAutoPasteFromClipboard(false);
		}
	}

	public void disableAutoSourceActions() {
		for (int i = 0; i < selectors.size(); i++) {
			selectors.get(i).setAutoCopyToSource(false);
			selectors.get(i).setAutoPasteFromSource(false);
		}
	}
}
