package cz.wz.milanl.colors.views;

import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;

import cz.wz.milanl.colors.selectors.ColorSelector;
import cz.wz.milanl.colors.selectors.SelectorBar;

public class ColorView {
	private Canvas color;
	private SelectorBar selectorBar;

	public ColorView(Composite parent) {
		color = new Canvas(parent, 0);

		FormData data = new FormData();
		data.top = new FormAttachment(0);
		data.bottom = new FormAttachment(0, 20);
		data.left = new FormAttachment(0);
		data.right = new FormAttachment(100);
		color.setLayoutData(data);

		color.setBackground(new Color(null, 255, 0, 0));

		color.addMouseListener(new MouseListener() {
			public void mouseDoubleClick(MouseEvent e) {

			}

			public void mouseDown(MouseEvent e) {
				selectorBar.refreshAllSelectors();
			}

			public void mouseUp(MouseEvent e) {
			}

		});
	}

	public void changeColor(RGB rgb, ColorSelector ignore) {
		color.setBackground(new Color(null, rgb));
		selectorBar.refreshAllSelectors(ignore);
	}

	public RGB getColor() {
		return color.getBackground().getRGB();
	}

	public void setSelectorBar(SelectorBar selectorBar) {
		this.selectorBar = selectorBar;
		selectorBar.refreshAllSelectors(null);
	}

	public void setFocus() {
		color.setFocus();
	}
}
