package cz.wz.milanl.util;

public class Numbers {
	private static final char chars[] = { '0', '1', '2', '3', '4', '5', '6',
			'7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };

	public static boolean isNumeric(String text) {
		for (int i = 0; i < text.length(); i++) {
			if (!isNumeric(text.charAt(i)))
				return false;
		}
		return true;
	}

	public static boolean isNumeric(char ch) {
		return ch >= 48 && ch <= 57;
	}

	public static int toNumber(String text) {
		return Integer.parseInt(text);
	}

	private static int charIndex(char ch) {
		for (int i = 0; i < chars.length; i++) {
			if (chars[i] == ch) {
				return i;
			}
		}
		return -1;
	}

	public static boolean isHex(String text) {
		for (int i = 0; i < text.length(); i++) {
			if (!isHex(text.charAt(i)))
				return false;
		}
		return true;
	}

	public static boolean isHex(char ch) {
		return isNumeric(ch) || (ch >= 'a' && ch <= 'f')
				|| (ch >= 'A' && ch <= 'F');
	}

	public static String toHex(int num) {
		return "" + chars[num / 16] + chars[num % 16];
	}

	public static int fromHex(String text) {
		text = text.toLowerCase();
		return charIndex(text.charAt(0)) * 16 + charIndex(text.charAt(1));
	}

	public static int[] getFirstNumbers(String text, int count, int def) {
		int[] result = new int[count];
		for (int i = 0; i < count; i++) {
			result[i] = def;
		}
		char ch;
		String number = "";
		int found = 0;
		for (int i = 0; i < text.length(); i++) {
			ch = text.charAt(i);
			if (isNumeric(ch)) {
				number += ch;
			}

			if ((!isNumeric(ch) || i == text.length() - 1)
					&& !number.equals("")) {
				result[found] = Integer.parseInt(number);

				number = "";
				found++;
				if (found == count)
					break;
			}
		}

		return result;
	}

	public static char[] getFirstHexNumbers(String text, int count, char def) {
		char[] result = new char[count];
		for (int i = 0; i < count; i++) {
			result[i] = def;
		}
		char ch;
		int found = 0;
		for (int i = 0; i < text.length(); i++) {
			ch = text.charAt(i);
			if (isHex(ch)) {
				result[found] = ch;
				found++;
				if (found == count)
					break;
			}
		}

		return result;
	}
}
