package cz.wz.milanl.util;

import java.awt.AWTException;

import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.Robot;


import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import cz.wz.milanl.colors.views.ColorView;

public class ScreenSelector extends Thread {
	private ColorView colorView;
	private Shell mainShell;
	private Shell shell;
	private Display display;

	private Robot r;
	private Point p;
	private java.awt.Color c;

	private RGB rgb;

	private boolean stop;
	private boolean shellOpened;

	public ScreenSelector(ColorView colorView, Shell mainShell) {
		this.colorView = colorView;
		this.mainShell = mainShell;

		try {
			r = new Robot();
		} catch (AWTException e) {
		}

		display = Display.getDefault();

		shell = new Shell(display, SWT.NO_TRIM | SWT.ON_TOP);
		shell.setCursor(new org.eclipse.swt.graphics.Cursor(null,	SWT.CURSOR_CROSS));
		shell.addMouseListener(new MouseListener() {

			public void mouseDown(MouseEvent e) {
				end();
			}

			public void mouseUp(MouseEvent e) {
			}

			public void mouseDoubleClick(MouseEvent e) {
			}
		});

		start();
	}

	private void refreshColor() {
		p = MouseInfo.getPointerInfo().getLocation();
		c = r.getPixelColor(p.x, p.y);

		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				rgb = new RGB(c.getRed(), c.getGreen(), c.getBlue());
				colorView.changeColor(rgb, null);
				shell.setBounds(p.x, p.y, 1, 1);
				shell.setBackground(new Color(null, rgb));
				if (!shellOpened) {
					shell.open();
					shellOpened = true;
				}
			}
		});
	}

	public void end() {
		stop = true;
		shell.close();
		mainShell.setMinimized(false);
	}

	public void run() {
		while (!stop) {
			refreshColor();
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
			}
		}
	}
}
